(function($, owner) {
	
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (!checkPhone(loginInfo.account)) {
			return callback('账号格式不正确');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		
		//开启等待雪花
		plus.nativeUI.showWaiting();
		
		var data = {
			AccountName:Encrypt_URIencode(loginInfo.account),
			LoginPwd:Encrypt_URIencode(loginInfo.password)
		};
		
//		console.log(JSON.stringify(data));
		$.post(appConfig.baseUrl+'MemberCenter/Login',data,function(response){
//			console.log(JSON.stringify(response));
			if(response.Code != 1){
				return callback(response.Msg);
			}
			
			//登陆成功
			var loginGuid_crypted=Encrypt_URIencode(DecryptWithHelper(response.UserState,Decrypt(response.Key),Decrypt(response.Helper)));
//			console.log(DecryptWithHelper(response.UserState,Decrypt(response.Key),Decrypt(response.Helper)));
			GetUserInfoSer(loginGuid_crypted,function(userInfo,err){
				if(err){
					return callback(err);
				}
				
				plus.storage.removeItem('userInfo');
				SetUserInfo(userInfo);
				return callback();
			});
			
		},'json');
	};

	owner.getCodeSMS = function(phone, index, callback){
		callback = callback || $.noop;
		phone = phone || '';
		
		if(!checkPhone(phone)){
			return callback('请输入正确的手机号');
		}
		
		var apiUrl = ['MemberCenter/GainCaptcha','MemberCenter/RetrievePwdCaptcha'];
		
		$.post(appConfig.baseUrl+apiUrl[index], {AccountName:phone}, function(response){
//			console.log(JSON.stringify(response));
			if(response.Code != 2){
				plus.nativeUI.toast('验证码错误失败，code：'+response.Code);
			}
		}, 'json');
		return callback();
	}

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		regInfo.category = regInfo.category || '';
		regInfo.code = regInfo.code || '';
		
		if(!checkPhone(regInfo.account)){
			return callback('请输入正确的手机号');
		}
		if(regInfo.code.length == 0){
			return callback('请输入验证码');
		}
		
		if (regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		if(regInfo.category.length == 0){
			return callback('请选择类别');
		}
		
		//开启等待雪花
		plus.nativeUI.showWaiting();
		
		var cityName = getCurCityName();
		
		//提交注册信息
		var regData={
			AccountName: Encrypt_URIencode(regInfo.account),
			LoginPwd:Encrypt_URIencode(regInfo.password),
			UserClass:Encrypt_URIencode(regInfo.category),
			Captcha:Encrypt_URIencode(regInfo.code),
			CityName:Encrypt_URIencode(cityName)
		};
//			console.log(JSON.stringify(regData));
		$.post(appConfig.baseUrl+'MemberCenter/Register', regData, function(response){
//			console.log(JSON.stringify(response));
			if(response.Code != 1){
				return callback(response.Msg);
			}
			
			//注册成功
			var loginGuid_crypted=Encrypt_URIencode(DecryptWithHelper(response.UserState,Decrypt(response.Key),Decrypt(response.Helper)));
			GetUserInfoSer(loginGuid_crypted,function(userInfo,err){
				if(err){
					return callback(err);
				}
				
				plus.storage.removeItem('userInfo');
				owner.setSettings({autoLogin:'1'});
				SetUserInfo(userInfo);
				return callback();
			});
			
			//注册成功
//			var userInfo = {
//				CallNumber:regInfo.account,
//				UserClass:regInfo.category,
//				CityName:cityName,
//				LoginGuid:DecryptWithHelper(response.UserState,Decrypt(response.Key),Decrypt(response.Helper))
//			};
//			
//			plus.storage.removeItem('userInfo');
//			owner.setSettings({autoLogin:'1'});
//			SetUserInfo(userInfo);
//			return callback();
			}, 'json');
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	var checkPhone = function(phone){
		phone = phone || '';
		return (phone.length == 11);
	}
	
	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(data, callback) {
		callback = callback || $.noop;
		data = data || {};
		data.account = data.account || '';
		data.password = data.password || '';
		data.code = data.code || '';
		
		if(!checkPhone(data.account)){
			return callback('请输入正确的手机号');
		}
		if(data.code.length == 0){
			return callback('请输入验证码');
		}
		
		if (data.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		
		//开启等待雪花
		plus.nativeUI.showWaiting();
//		console.log(JSON.stringify(data));
		//加密数据
		var submitData = {
			AccountName : Encrypt(data.account),
			LoginPwd : Encrypt(data.password),
			Captcha : Encrypt(data.code)
		};
//		console.log(JSON.stringify(submitData));
		//提交信息
		$.post(appConfig.baseUrl + 'MemberCenter/RetrievePwd',submitData,function(response){
//			console.log(JSON.stringify(response));
			if(response.Code != 1){
				return callback(response.Msg);
			}
			return callback();
		},'json');
	};

	/**
	 * 设置应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		plus.storage.setItem('settings', JSON.stringify(settings));
	}

	/**
	 * 获取应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = plus.storage.getItem('settings') || "{}";
		return JSON.parse(settingsText);
	}
}(mui, window.app = {}));