/**
 * 加密
 * @param {String} word
 */
function Encrypt(word){
     var key = CryptoJS.enc.Utf8.parse(appConfig.aes_key);    
     var iv  = CryptoJS.enc.Utf8.parse(appConfig.aes_iv);    
     var srcs = CryptoJS.enc.Utf8.parse(word);   
     var encrypted = CryptoJS.AES.encrypt(srcs, key, { iv: iv,mode:CryptoJS.mode.CBC,padding:CryptoJS.pad.Pkcs7});   
     return encrypted.toString();   
}
/**
 * 加密，返回URI编码字符串
 * @param {String} word
 */
function Encrypt_URIencode(word){
	return Encrypt(word);
//	return encodeURIComponent(Encrypt(word));
}
/**
 * 解密
 * @param {String} word
 */
function Decrypt(word){   
     var key = CryptoJS.enc.Utf8.parse(appConfig.aes_key);    
     var iv  = CryptoJS.enc.Utf8.parse(appConfig.aes_iv);    
     var decrypted = CryptoJS.AES.decrypt(word, key, { iv: iv,mode:CryptoJS.mode.CBC,padding:CryptoJS.pad.Pkcs7});   
     return CryptoJS.enc.Utf8.stringify(decrypted).toString();   
}   
/**
 * 二次加密
 * @param {String} word
 * @param {String} key
 * @param {String} iv
 */
function EncryptWithHelper(word,key,iv){  
	 key = CryptoJS.enc.Utf8.parse(key);    
     iv  = CryptoJS.enc.Utf8.parse(iv);
     var srcs = CryptoJS.enc.Utf8.parse(word);   
     var encrypted = CryptoJS.AES.encrypt(srcs, key, { iv: iv,mode:CryptoJS.mode.CBC,padding:CryptoJS.pad.Pkcs7});   
     return encrypted.toString();   
}
/**
 * 二次解密
 * @param {String} word
 * @param {String} key
 * @param {String} iv
 */
function DecryptWithHelper(word,key,iv){    
	 key = CryptoJS.enc.Utf8.parse(key);    
     iv  = CryptoJS.enc.Utf8.parse(iv);
     var decrypted = CryptoJS.AES.decrypt(word, key, { iv: iv,mode:CryptoJS.mode.CBC,padding:CryptoJS.pad.Pkcs7});   
     return CryptoJS.enc.Utf8.stringify(decrypted).toString();   
}
/**
 * 本地记录用户信息
 * @param {Array} userInfo
 */
function SetUserInfo(userInfo){
	userInfo = userInfo || {};
	plus.storage.setItem('userInfo', JSON.stringify(userInfo));
}
/**
 * 获取本地记录的用户信息
 */
function GetUserInfo(){
	var userInfoText = plus.storage.getItem('userInfo') || "{}";
	return JSON.parse(userInfoText);
}
/**
 * 从服务器获取用户信息
 * @param {String} LoginGuid
 * @param {Function} callback
 */
function GetUserInfoSer(LoginGuid,callback){
	mui.post(appConfig.baseUrl+'MemberCenter/LoginUser',{LoginGuid:LoginGuid},function(response){
//		console.log(JSON.stringify(response));
		if(response.Code != 1){
			return callback(null,response.Msg);
		}
		
		var data = JSON.parse(DecryptWithHelper(response.Value,Decrypt(response.Key),Decrypt(response.Helper)));
//		console.log(JSON.stringify(data));
		var userInfo = {
			NickName : data.NickName,
			HeadImg : data.HeadImg,
			TrueName : data.TrueName,
			CallNumber : data.CallNumber,
			UserSex : data.UserSex,
			CityGuid : data.CityGuid,
			CityName : data.CityName,
			UserClass : data.UserClass,
			LoginGuid : data.LoginGuid,
			BusinessId : data.BusinessId,
			FocusCount : data.FocusCount,
			ByFocusCount : data.ByFocusCount
		};
		SetUserInfo(userInfo);
		return callback(userInfo,null);
	},'json');
}
/**
 * 字符串转utf8编码
 * @param {String} str
 */
function encodeUTF8(str){  
	var temp = "",rs = "";  
	for( var i=0 , len = str.length; i < len; i++ ){  
	    temp = str.charCodeAt(i).toString(16);  
	    rs  += "\\u"+ new Array(5-temp.length).join("0") + temp;  
	}  
	return rs;  
}
/**
 * 格式化日期函数
 * @param {String} datetime
 */
function formatDatatime(datetime){
	datetime = datetime.replace('T',' ').replace(/-/g,'/');
	var _datetime = new Date(datetime);
	var dtime = _datetime.getTime();
	var tnow =  new Date().getTime();
	var difftime = tnow - dtime;
	
	var minutes =( _datetime.getMinutes() < 10 ? '0' :'' ) + _datetime.getMinutes();
	
	if(difftime < 600000){
		return '刚刚';
	}else if(difftime < 3600000){
		return Math.floor(difftime/60000) + '分前';
	}else if(difftime < 86400000){
		return Math.floor(difftime/3600000) + '小时前';
	}else if(difftime < 172800000){
		return '昨天 ' + _datetime.getHours() + ':' + minutes;
	}else if(difftime < 777600000){
		return '前天 ' + _datetime.getHours() + ':' + minutes;
	}else{
		return _datetime.getMonth() + '月' + _datetime.getDate() + '日';
	}
	
}
/**
 * 从百度获取当前城市名称
 * @param {Function} callback
 */
function getCityName(callback){
	//定位
	plus.geolocation.getCurrentPosition(function(position){
		var codns = position.coords; //获取地理坐标信息；
		var req = 'http://api.map.baidu.com/geocoder/v2/';
		var parms = {
			ak: appConfig.bd_ak,
			callback: 'renderReverse',
			output: 'json',
			location: codns.latitude + ',' + codns.longitude,
			mcode:appConfig.bd_mcode
		};
		mui.ajax(req, {
			data: parms,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
//				console.log(JSON.stringify(data));
//				plus.storage.setItem('geolocation',data);
				if (data.status != 0) {
					return callback('定位失败，请重试',null);
				}
				
				var city = data.result.addressComponent.city;
				if(city.indexOf('市') > -1){
					city = city.replace('市','');
				}
//				console.log(city);
				return callback(null,city);
			}
		});
	},function ( e ) {},{provider:'baidu'});
}
/**
 * 获取当前城市名称
 */
function getCurCityName(){
	var curCity = plus.storage.getItem('curCity') || '';
	if(curCity)
		return curCity;
	
	var userInfo = GetUserInfo();
	if(userInfo.CityName)
		return userInfo.CityName;
	
	return '石家庄';
}
/**
 * 检查用户是否登陆
 */
function checkLogin(){
	var userInfo = GetUserInfo();
	if(userInfo.LoginGuid)
		return true;
	
	mui.openWindow({
		url : 'login.html',
		id : 'login',
		show : {
			aniShow: 'slide-in-right',
			duration:300
		},
		styles: {
			popGesture: 'hide'
		},
		waiting: {
			autoShow: false
		}
	});
	return false;
}
/**
 * 退出登录
 */
function quitOut(){
	var bts=["是","否"];
	plus.nativeUI.confirm("退出登录？",function(e){
		var i=e.index;
		if(i == 0){
			//清空用户数据
			plus.storage.removeItem('userInfo');
			//转到登录页面
			mui.openWindow({
				url : 'login.html',
				id : 'login',
				show : {
					aniShow: 'slide-in-right',
					duration:300
				},
				styles: {
					popGesture: 'hide'
				},
				extras:{
					flag:'quit'
				},
				waiting: {
					autoShow: false
				}
			});
		}
	},null,bts);
}
/**
 * 登陆后需要重新激活的事件
 */
function refireEvent(){
	//我
	var index_user =  plus.webview.getWebviewById('index_user');
	mui.fire(index_user,'reshow',{});
	
	//我——修改资料
	var user_base = plus.webview.getWebviewById('user_base');
	mui.fire(user_base,'reshow',{});
	
	//我——商家信息
	var user_shangjia = plus.webview.getWebviewById('user_shangjia');
	mui.fire(user_shangjia,'reshow',{});
	
	//渔乐圈——同城
	var list_yubo_info =  plus.webview.getWebviewById('list_yubo_info');
	mui.fire(list_yubo_info,'setLoginGuid',{});
	
	//渔乐圈——全国
	var list_yubo_info_all =  plus.webview.getWebviewById('list_yubo_info_all');
	mui.fire(list_yubo_info_all,'setLoginGuid',{});
}
/**
 * 检查更新
 */
function checkVersion(){
	mui.post(appConfig.baseUrl + 'Upgrade/AndroidRelease',{VersionNumber:plus.runtime.version},function(response){
//		console.log(JSON.stringify(response));
		
		if(response.Code ==  1){
			var bts=["下载新版本","暂不更新"];
			plus.nativeUI.confirm("发现新版本，是否更新？",function(e){
				var i=e.index;
				if(i == 0){
					plus.runtime.openURL(appConfig.baseUrl + response.Value);
				}
			},null,bts);
		}
		
	},'json');
}
/**
 * 打开外部视频播放器
 */
function playVideo(url){
	var Intent = plus.android.importClass("android.content.Intent");
    var Uri = plus.android.importClass("android.net.Uri");
    var main = plus.android.runtimeMainActivity();
    var intent=new Intent(Intent.ACTION_VIEW);
    var uri=Uri.parse(url);
    intent.setDataAndType(uri,"video/*");
    main.startActivity(intent);
}
/**
 * 加密电话号码中间4位
 * @param {String} phone
 */
function getPhoneNumberWithStar(phone){
	return phone.substr(0,3) + '****' + phone.substr(7);
}
/**
 * 去除字符串两端空格
 * @param {String} s
 */
function trim(s){
    return s.replace(/(^\s*)|(\s*$)/g, "");
}